###
# Copyright (c) 2024, codey
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#   * Redistributions of source code must retain the above copyright notice,
#     this list of conditions, and the following disclaimer.
#   * Redistributions in binary form must reproduce the above copyright notice,
#     this list of conditions, and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   * Neither the name of the author of this software nor the name of
#     contributors to this software may be used to endorse or promote products
#     derived from this software without specific prior written consent.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

###

from supybot import conf, registry
try:
    from supybot.i18n import PluginInternationalization
    _ = PluginInternationalization('Lyrics')
except:
    _ = lambda x: x


def configure(advanced):

    from supybot.questions import expect, anything, something, yn
    conf.registerPlugin('Lyrics', True)


Lyrics = conf.registerPlugin('Lyrics')



conf.registerChannelValue(Lyrics,
                          "enable",
                          registry.Boolean(
                              True, _("""Should Lyrics respond in this channel?""")
                          ))

conf.registerChannelValue(Lyrics,
                          "truncate",
                          registry.Boolean(
                              True, _("""Should Lyrics responses be truncated in this channel?""")
                          ))

conf.registerChannelValue(Lyrics,
                          "lines",
                          registry.Integer(
                              1, _("""If truncate is set to true, how many lines should be sent (initially)?""")
                          ))

conf.registerChannelValue(Lyrics,
                          "mores",
                          registry.Boolean(
                              True, _("""If truncate is set to true, should mores be used to allow responses to be continued?""")
                          ))

conf.registerChannelValue(Lyrics,
                          "quiet",
                          registry.Boolean(
                              False, _("""If quiet is set True, Searching... and Found: output will be entirely suppressed.""")
                          ))

conf.registerChannelValue(Lyrics,
                          "verbose",
                          registry.Boolean(
                              False, _("""Send Searching... and Found: output to command context instead of privately via notice. Has no impact if quiet is set to True.""")
                          ))


conf.registerGlobalValue(Lyrics,
                          "floodexempt",
                          registry.Boolean(
                              False, _("""If set, the bot will not delay messages sent when truncation is set to False.  This usually requires the bot to have a special connect/oper class, to prevent SendQ/RecvQ quits.""")
                          ))

conf.registerGlobalValue(Lyrics, "host", registry.String(
    "https://api.codey.lol/lyric_search/", _("""API Host for Lyric Search"""), private=True,
))
